//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.3603
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

#define MSSQL
#define SSAS
#define Sybase_ASE
#define Sybase_Anywhere
#define Sybase_UltraLite
#define Sybase_Advantage
#define Sap_Hana
#define Oracle
#define Firebird
#define PostgreSQL
#define MySQL
#define DB2
#define Ingres
#define SQL_Azure
#define RedisCache
#define Sqlite
#define Informix
#define Interbase
#define Vertica
#define MongoDb
#define Redis
#define Cassandra
#define Neo4j
#define InfluxDb

using System;
using Gtk;
using System.Collections.Generic;
using Pango;
using Microsoft.FSharp.Collections;
using SqlDynamite.Common;
using SqlDynamite.Util;

namespace SqlDynamiteX
{
    public partial class ConfigWindow : Dialog
    {
        public string _ConnectionName
        {
            get { return ConnectionName.Text; }
            set { ConnectionName.Text = value; }
        }
        public string _ServerType
        {
            get { return ServerType.ActiveText; }
            set { ServerType.SetComboBoxText(value); }
        }
        public string _Driver
        {
            get { return Driver.ActiveText; }
            set { Driver.SetComboBoxText(value); }
        }
        public string _Server
        {
            get { return Server.Text; }
            set { Server.Text = value; }
        }
        public string _Database
        {
            get { return Database.ActiveText; }
            set { Database.Entry.Text = value; }
        }
        public string _User
        {
            get { return User.Text; }
            set { User.Text = value; }
        }
        public string _Password
        {
            get { return Password.Text; }
            set { Password.Text = value; }
        }
        public bool _SSPI
        {
            get { return SSPI.Active; }
            set { SSPI.Active = value; }
        }

        public ConnectionType _ConnectionType
        {
            get { return ODBC.Active ? ConnectionType.ODBC : ConnectionType.NET; }
            set { ODBC.Active = value == ConnectionType.ODBC; }
        }

        public static GtkSyntaxProvider SyntaxProvider => gtkSyntaxProvider;

        private static readonly GtkSyntaxProvider gtkSyntaxProvider = new GtkSyntaxProvider();

        private static readonly string[] fileDbs = new []{"Firebird","SAP IQ","SAP Anywhere","SAP UltraLite",
                                                          "SAP Advantage","SQLite","Interbase"};

        static ConfigWindow()
        {
            gtkSyntaxProvider.LoadWords(Properties.Resources.ansi_keywords, gtkSyntaxProvider.KeywordColor);
            gtkSyntaxProvider.LoadWords(Properties.Resources.ansi_functions, gtkSyntaxProvider.FunctionColor);
            gtkSyntaxProvider.LoadWords(Properties.Resources.ansi_types, gtkSyntaxProvider.TypeColor);
        }

        public ConfigWindow()
		{
			Build ();
            IEnumerable<string> drivers = DataUtil.GetOdbcDrivers();
            foreach (string driver in drivers)
            {
                Driver.AppendText(driver);
            }
#if MSSQL
            ServerType.AppendText("MSSQL");
#endif
#if SSAS
            ServerType.AppendText("SQL Analysis Services");
#endif
#if Oracle
            ServerType.AppendText("Oracle");
#endif
#if PostgreSQL
            ServerType.AppendText("PostgreSQL");
#endif
#if DB2
            ServerType.AppendText("DB2");
#endif
#if Sybase_ASE
            ServerType.AppendText("SAP ASE");
#endif
#if Sybase_Anywhere
            ServerType.AppendText("SAP Anywhere");
            ServerType.AppendText("SAP IQ");
#endif
#if Sybase_UltraLite
            ServerType.AppendText("SAP UltraLite");
#endif
#if Sybase_Advantage
            ServerType.AppendText("SAP Advantage");
#endif
#if Sap_Hana
            ServerType.AppendText("SAP HANA");
#endif
#if MySQL
            ServerType.AppendText("MySQL");
#endif
#if Firebird
            ServerType.AppendText("Firebird");
#endif
#if Ingres
            ServerType.AppendText("Ingres");
#endif
#if SQL_Azure
            ServerType.AppendText("SQL Azure");
#endif
#if RedisCache
            ServerType.AppendText("Azure Redis Cache");
#endif
#if Sqlite
            ServerType.AppendText("SQLite");
#endif
#if Informix
            ServerType.AppendText("Informix");
#endif
#if Interbase
            ServerType.AppendText("Interbase");
#endif
#if Vertica
            ServerType.AppendText("Vertica");
#endif
#if MongoDb
            ServerType.AppendText("MongoDb");
#endif
#if Redis
            ServerType.AppendText("Redis");
#endif
#if Cassandra
            ServerType.AppendText("Cassandra");
#endif
#if Neo4j
            ServerType.AppendText("Neo4j");
#endif
#if InfluxDb
            ServerType.AppendText("InfluxDb");
#endif
        }

        public void Initialize()
        {
            SspiCheck();
            OnServerTypeChanged(this, null);
            OnODBCToggled(this, null);
        }

        protected virtual void OnServerTypeChanged(object sender, EventArgs e)
		{
            if (ServerType.Active >= 0)
            {
                OdbcCheck();
                bool sspiAvailable = ServerType.ActiveText.Contains("MSSQL") ||
                                 ServerType.ActiveText.Contains("SQL Analysis Services") ||
                                 ServerType.ActiveText.Contains("Oracle") ||
                                 ServerType.ActiveText.Contains("PostgreSQL");
                Server.Sensitive = !(ServerType.ActiveText.Contains("SQLite") || 
                                     ServerType.ActiveText.Contains("SAP UltraLite") || 
                                     ServerType.ActiveText.Contains("SAP Advantage"));
                SSPI.Sensitive = sspiAvailable;
                if (!sspiAvailable) SSPI.Active = false;
                CombineConnectionString();
                if (Array.Exists(fileDbs, x => x == ServerType.ActiveText))
                {
                    this.button7.Label = "Select DB";
                }
                else
                {
                    this.button7.Label = "DB List";
                }
            }
		}

		private void SspiCheck()
        {
            if (!SSPI.Active)
            {
                User.Sensitive = true;
                Password.Sensitive = true;
            }
            else
            {
                User.Sensitive = false;
                Password.Sensitive = false;
            }
            CombineConnectionString();
        }

		private void OdbcCheck()
        {
            if (ODBC.Active)
            {
                Driver.Sensitive = true;
                button7.Visible = false;
            }
            else
            {
                Driver.Active = -1;
                Driver.Sensitive = false;
                button7.Visible = true;
            }
            if (ServerType.Active >= 0)
            {
                label6.Text = ServerType.ActiveText.Contains("Informix") ? "Instance/DB" : "Database";
                CombineConnectionString();
            }
        }

		protected virtual void OnODBCToggled (object sender, EventArgs e)
		{
			OdbcCheck();
		}
		
		protected virtual void OnSSPIToggled (object sender, EventArgs e)
		{
			SspiCheck();
		}
		
		protected virtual void OnButton263Clicked (object sender, EventArgs e)
		{
			Hide();
		}

	    protected virtual void OnButtonCancelClicked(object sender, EventArgs e)
	    {
	        string str = "";
	        if (ConnectionName.Text == "") str += "Connection name is empty" + Environment.NewLine;
	        if (string.IsNullOrWhiteSpace(ServerType.ActiveText)) str += "Database server type is empty" + Environment.NewLine;
	        if (string.IsNullOrWhiteSpace(Server.Text) &&
	            (ServerType.ActiveText == null ||
	             !(ServerType.ActiveText.Contains("SQLite") || 
	               ServerType.ActiveText.Contains("SAP UltraLite") || 
	               ServerType.ActiveText.Contains("SAP Advantage"))))
	            str += "Server name or IP address is empty";
	        if (str != "")
	        {
	            var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Warning, ButtonsType.Ok, str);
	            md.Run();
	            md.Destroy();
	        }
	        else Hide();
	    }

	    protected virtual void OnButtonOkClicked(object sender, EventArgs e)
	    {
	        string str = "";
	        if (string.IsNullOrWhiteSpace(ServerType.ActiveText)) str += "Database server type is empty" + Environment.NewLine;
	        if (string.IsNullOrWhiteSpace(Server.Text) &&
	            (ServerType.ActiveText == null ||
	             !(ServerType.ActiveText.Contains("SQLite") || 
	               ServerType.ActiveText.Contains("SAP UltraLite") || 
	               ServerType.ActiveText.Contains("SAP Advantage"))))
	            str += "Server name or IP address is empty";
	        if (str != "")
	        {
	            var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Warning, ButtonsType.Ok, str);
	            md.Run();
	            md.Destroy();
	            return;
	        }
	        if (ServerType.Active >= 0)
	        {
	            MetadataFinder mf = CreateMetadataFinder(ServerType.ActiveText);
	            try
	            {
	                string cstring = mf.MakeConnectionString(
	                    string.IsNullOrWhiteSpace(Driver.ActiveText) ? "" : Driver.ActiveText,
	                    Server.Text, Database.ActiveText, User.Text, Password.Text, SSPI.Active,
                        ODBC.Active ? ConnectionType.ODBC : ConnectionType.NET);
                    if (!string.IsNullOrWhiteSpace(cstring))
                    {
                        mf.EstablishConnection(cstring, ODBC.Active ? ConnectionType.ODBC : ConnectionType.NET, Database.ActiveText);
                    }
                    else
                    {
                        var md_ = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, "Connection string is empty") { Title = "Error" };
                        md_.Run();
                        md_.Destroy();
                        return;
                    }
                    var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Info, ButtonsType.Ok,
	                    "Connection successfull");
	                md.Run();
	                md.Destroy();
	            }
                catch (Exception exception)
	            {
	                var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, exception.GetExceptionMessages());
	                md.Run();
	                md.Destroy();
	            }
	        }
	    }

        public static MetadataFinder CreateMetadataFinder(string serverType)
        {
            MetadataFinder finder;
            Color keywordColor = gtkSyntaxProvider.KeywordColor;
            Color functionColor = gtkSyntaxProvider.FunctionNoAnsiColor;
            Color typeColor = gtkSyntaxProvider.TypeColor;
            switch (serverType)
            {
#if Sybase_ASE
                case "SAP ASE":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_types, typeColor);
                    finder = new SybaseMetadataFinder();
                    break;
#endif
#if Sybase_Anywhere
                case "SAP Anywhere":
                case "SAP IQ":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.watcom_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.watcom_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.watcom_types, typeColor);
                    finder = new SybaseAnywhereMetadataFinder();
                    break;
#endif
#if Sybase_Advantage
                case "SAP Advantage":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new SybaseAdvantageMetadataFinder();
                    break;
#endif
#if Sap_Hana
                case "SAP HANA":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new SapHanaMetadataFinder();
                    break;
#endif
#if Oracle
                case "Oracle":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.pl_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.pl_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.pl_types, typeColor);
                    finder = new OracleMetadataFinder();
                    break;
#endif
#if Firebird
                case "Firebird":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.psql_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.psql_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.psql_types, typeColor);
                    finder = new FirebirdMetadataFinder();
                    break;
#endif
#if Ingres
                case "Ingres":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new IngresMetadataFinder();
                    break;
#endif
#if SQL_Azure
                case "SQL Azure":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_types, typeColor);
				finder = new SqlAzureMetadataFinder();
                    break;
#endif
#if RedisCache
                case "Azure Redis Cache":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new RedisMetadataFinder();
                    break;
#endif
#if PostgreSQL
                case "PostgreSQL":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.pl_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.pl_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.pl_types, typeColor);
                    finder = new PostgreSqlMetadataFinder();
                    break;
#endif
#if MySQL
                case "MySQL":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.mysql_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.mysql_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.mysql_types, typeColor);
                    finder = new MySqlMetadataFinder();
                    break;
#endif
#if SSAS
                case "SQL Analysis Services":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new SsasMetadataFinder();
                    break;
#endif
#if MSSQL
                case "MSSQL":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.transact_types, typeColor);
                    finder = new MsSqlMetadataFinder();
                    break;
#endif
#if DB2
                case "DB2":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.db2_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.db2_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.db2_types, typeColor);
                    finder = new Db2MetadataFinder();
                    break;
#endif
#if Sqlite
                case "SQLite":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new SqliteMetadataFinder();
                    break;
#endif
#if Informix
                case "Informix":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new InformixMetadataFinder();
                    break;
#endif
#if Interbase
                case "Interbase":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.psql_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.psql_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.psql_types, typeColor);
                    finder = new InterbaseMetadataFinder();
                    break;
#endif
#if Sybase_UltraLite
                case "SAP UltraLite":
                    gtkSyntaxProvider.UnloadWords();
                    gtkSyntaxProvider.LoadWords(Properties.Resources.watcom_keywords, keywordColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.watcom_functions, functionColor);
                    gtkSyntaxProvider.LoadWords(Properties.Resources.watcom_types, typeColor);
                    finder = new UltraliteMetadataFinder();
                    break;
#endif
#if Vertica
                case "Vertica":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new VerticaMetadataFinder();
                    break;
#endif
#if MongoDb
                case "MongoDb":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new MongoDbMetadataFinder();
                    break;
#endif
#if Redis
                case "Redis":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new RedisMetadataFinder();
                    break;
#endif
#if Cassandra
                case "Cassandra":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new CassandraMetadataFinder();
                    break;
#endif
#if Neo4j
                case "Neo4j":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new Neo4jMetadataFinder();
                    break;
#endif
#if InfluxDb
                case "InfluxDb":
                    gtkSyntaxProvider.UnloadWords();
                    finder = new InfluxDbMetadataFinder();
                    break;
#endif
                default:
                    finder = null;
                    break;
            }
            return finder;
        }
        
        protected virtual void OnButton7Clicked (object sender, EventArgs e)
		{
            string str = "";
            if (string.IsNullOrWhiteSpace(ServerType.ActiveText)) str += "Database server type is empty" + Environment.NewLine;
            if (string.IsNullOrWhiteSpace(Server.Text) && (ServerType.ActiveText == null || !Array.Exists(fileDbs, x => x == ServerType.ActiveText)))
                str += "Server name or IP address is empty";
            if (str != "")
            {
                var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Warning, ButtonsType.Ok, str);
                md.Run();
                md.Destroy();
                return;
            }
            if (ServerType.Active >= 0 && ServerType.Active != 2)
            {
                MetadataFinder mf = CreateMetadataFinder(ServerType.ActiveText);
                try
                {
                    string cstring = mf.MakeConnectionString(
                        string.IsNullOrWhiteSpace(Driver.ActiveText) ? "" : Driver.ActiveText,
                        Server.Text, Database.ActiveText, User.Text, Password.Text, SSPI.Active,
                        ODBC.Active ? ConnectionType.ODBC : ConnectionType.NET);
                    if (!string.IsNullOrWhiteSpace(cstring) && !Array.Exists(fileDbs, x => x == ServerType.ActiveText))
                    {
                        mf.EstablishConnection(cstring, ODBC.Active ? ConnectionType.ODBC : ConnectionType.NET, Database.ActiveText);
                    }
                    else if (!Array.Exists(fileDbs, x => x == ServerType.ActiveText))
                    {
                        var md_ = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, "Connection string is empty") { Title = "Error" };
                        md_.Run();
                        md_.Destroy();
                        return;
                    }

                    if (Array.Exists(fileDbs, x => x == ServerType.ActiveText))
                    {
                        FileChooserDialog fcd = new FileChooserDialog("Open Database File", this, FileChooserAction.Open);
                        fcd.AddButton(Stock.Cancel, ResponseType.Cancel);
                        fcd.AddButton(Stock.Open, ResponseType.Ok);
                        fcd.DefaultResponse = ResponseType.Ok;
                        fcd.SelectMultiple = false;
                        FileFilter fileFilter = new FileFilter();
                        if (ServerType.ActiveText == "SQLite")
                        {
                            fileFilter.AddPattern("*.sqlite");
                            fileFilter.Name = "SQLite databases";
                        }
                        else if (ServerType.ActiveText == "Interbase")
                        {
                            fileFilter.AddPattern("*.gdb");
                            fileFilter.Name = "Interbase databases";
                        }
                        else if (ServerType.ActiveText == "Firebird")
                        {
                            fileFilter.AddPattern("*.fdb");
                            fileFilter.Name = "Firebird databases";
                        }
                        else if (ServerType.ActiveText == "SAP UltraLite")
                        {
                            fileFilter.AddPattern("*.udb");
                            fileFilter.Name = "UltraLite databases";
                        }
                        else if (ServerType.ActiveText == "SAP Anywhere" || ServerType.ActiveText == "SAP IQ")
                        {
                            fileFilter.AddPattern("*.db");
                            fileFilter.Name = ServerType.ActiveText == "SAP Anywhere" ? "SQL Anywhere databases" : "SAP IQ databases";
                        }
                        else if (ServerType.ActiveText == "SAP Advantage")
                        {
                            fileFilter.AddPattern("*.add");
                            fileFilter.Name = "SAP Advantage data dictionaries";
                        }
                        fcd.AddFilter(fileFilter);

                        ResponseType response = (ResponseType)fcd.Run();
                        if (response == ResponseType.Ok)
                            Database.SetComboBoxText(fcd.Filename);
                        fcd.Destroy();
                    }
                    else
                    {
                        FSharpList<string> list = mf.GetDatabaseList("Databases");
                        CellRendererText cell = new CellRendererText();
                        Database.PackStart(cell, false);
                        ListStore store = new ListStore(typeof(string));
                        Database.Model = store;
                        foreach (string s in list)
                        {
                            Database.AppendText(s);
                        }
                    }
                }
                catch (Exception exception)
                {
                    var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, exception.GetExceptionMessages());
                    md.Run();
                    md.Destroy();
                }
            }
            else
            {
                string[] text =
                    new ConsoleWorker().StartConsoleProgram("tnsping",
                                                            string.IsNullOrWhiteSpace(Server.Text)
                                                                ? "localhost"
                                                                : Server.Text).Split('\n');
                foreach (string s in text)
                {
                    if (s.Contains("sqlnet.ora"))
                    {
                        try
                        {
                            string tnsFile = s.Replace("sqlnet.ora", "tnsnames.ora");
                            var dbs = OracleMetadataFinder.GetDatabases(tnsFile);
                            CellRendererText cell = new CellRendererText();
                            Database.PackStart(cell, false);
                            ListStore store = new ListStore(typeof (string));
                            Database.Model = store;
                            foreach (string db in dbs)
                            {
                                Database.AppendText(db);
                            }
                        }
                        catch (Exception exception)
                        {
                            var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, exception.GetExceptionMessages());
                            md.Run();
                            md.Destroy();
							return;
                        }
                    }
                }
            }
        }

	    private void CombineConnectionString()
	    {
	        MetadataFinder mf = CreateMetadataFinder(ServerType.ActiveText);
	        if (mf == null) return;
	        string cstring =
	            mf.MakeConnectionString(string.IsNullOrWhiteSpace(Driver.ActiveText) ? "" : Driver.ActiveText,
	                Server.Text, Database.ActiveText, User.Text, Password.Text, SSPI.Active,
	                ODBC.Active ? ConnectionType.ODBC : ConnectionType.NET);

	        if (string.IsNullOrWhiteSpace(cstring) && ODBC.Active)
	        {
	            cstring = "Connection string generation is not implemented for " + ServerType.ActiveText + " ODBC drivers";
	        }

	        cstring = HidePswd(cstring);

	        ConnectionStringEntry.Buffer.Text = cstring;
	    }

	    private static string HidePswd(string cstring)
        {
            int pwdIndex = cstring.IndexOf("Password=", StringComparison.OrdinalIgnoreCase);
            if (pwdIndex == -1)
            {
                pwdIndex = cstring.IndexOf("Pwd=", StringComparison.OrdinalIgnoreCase);
                if (pwdIndex != -1)
                {
                    pwdIndex += 4;
                }
            }
            else
            {
                pwdIndex += 9;
            }
            if (pwdIndex != -1)
            {
                int scIndex = cstring.IndexOf(';', pwdIndex);
                string pswd = scIndex != -1 ? cstring.Substring(pwdIndex, scIndex - pwdIndex) : cstring.Substring(pwdIndex);
                if (!string.IsNullOrWhiteSpace(pswd))
                {
                    cstring = cstring.Replace(pswd, new string('*', pswd.Length));
                }
            }
            return cstring;
        }

        protected void Driver_Changed(object sender, EventArgs e)
		{
            CombineConnectionString();
        }

		protected void Server_Changed (object sender, EventArgs e)
		{
            CombineConnectionString();
        }

		protected void User_Changed (object sender, EventArgs e)
		{
            CombineConnectionString();
        }

		protected void Password_Changed (object sender, EventArgs e)
		{
            CombineConnectionString();
        }

		protected void Database_Changed (object sender, EventArgs e)
		{
            CombineConnectionString();
        }
    }
}
