//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.3603
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.IO;
using Gtk;
using SqlDynamite.Common;
using SqlDynamite.Util;

namespace SqlDynamiteX
{
	public partial class ListWindow : Dialog
	{
        internal static readonly string ConfigFile;

	    private string _connectionName;
        private string _serverType;
        private string _driver;
        private string _server;
        private string _database;
        private string _user;
        private string _password;
        private bool _sspi;
	    private ConnectionType _connectionType;
	    private string _defaultConnection;

        static ListWindow()
        {
            string appdata = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
            if (!Directory.Exists(appdata + "/SQL Dynamite"))
            {
                Directory.CreateDirectory(appdata + "/SQL Dynamite");
            }
            ConfigFile = appdata + "/SQL Dynamite/SQL_Dynamite.xml";
        }
        
		public ListWindow ()
		{
			Build ();
            FillConnections();
		}

		protected virtual void OnButton46Clicked (object sender, EventArgs e)
		{
            Hide();
		}

        private void FillConnections()
        {
            if (Connections.Columns.Length == 0)
            {
                CellRendererText cell = new CellRendererText();
                TreeViewColumn column = new TreeViewColumn("Database", cell);
                column.PackStart(cell, true);
                column.AddAttribute(cell, "text", 0);
                column.SetCellDataFunc(cell, RenderDatabaseName);
                Connections.AppendColumn(column);
            }
            ListStore store = new ListStore(typeof(string));
            Connections.Model = store;
            IEnumerable<Tuple<string, bool>> cns = XmlUtil.SelectConfig(ConfigFile);
            foreach (Tuple<string, bool> cn in cns)
            {
                if (cn.Item2) _defaultConnection = cn.Item1;
                store.AppendValues(cn.Item1);
            }
        }

	    private void RenderDatabaseName(TreeViewColumn treeColumn, CellRenderer cell, TreeModel treeModel, TreeIter iter)
	    {
	        object item = treeModel.GetValue(iter, 0);
	        (cell as CellRendererText).Background = item.ToString() == _defaultConnection ? "LightPink" : "White";
	    }

	    protected virtual void OnButtonCancelClicked (object sender, EventArgs e)
		{
		    ConfigWindow configWindow = new ConfigWindow();
            ResponseType result = (ResponseType) configWindow.Run();
            if (result == ResponseType.Ok)
            {
                _connectionName = configWindow._ConnectionName;
                _sspi = configWindow._SSPI;
                _serverType = configWindow._ServerType;
                _driver = configWindow._Driver;
                _server = configWindow._Server;
                _database = configWindow._Database;
                _user = configWindow._User;
                _password = configWindow._Password;
                _connectionType = configWindow._ConnectionType;
                ServerInfo serverInfo = new ServerInfo(_serverType, _driver, _server, _database, _user, _password, _sspi.ToString(), _connectionType.ToString(), _connectionName);
                XmlUtil.InsertConfig(ConfigFile, _connectionName, serverInfo);
                FillConnections();
            }
            configWindow.Destroy();
        }
		
        protected virtual void OnButton43Clicked (object sender, EventArgs e)
		{
            if (Connections.GetSelectedItem(0) != null)
            {
                object item;
                try
                {
                    item = Connections.GetSelectedItem(0);
                }
                catch (ArgumentException)
                {
                    return;
                }
                string cnf = item.ToString();
                ServerInfo crs = XmlUtil.SelectConfig(ConfigFile, cnf);
                if (crs != null)
                {
                    ConfigWindow configWindow = new ConfigWindow
                                                    {
                                                        _ConnectionName = cnf,
                                                        _ServerType = crs.ServerType,
                                                        _Driver = crs.Driver,
                                                        _Server = crs.Server,
                                                        _Database = crs.Database,
                                                        _User = crs.User,
                                                        _Password = crs.Password,
                                                        _SSPI = bool.Parse(crs.SSPI),
                                                        _ConnectionType = crs.ConnectionType == "ODBC" ? ConnectionType.ODBC : ConnectionType.NET
                                                    };
                    configWindow.Initialize();
                    ResponseType result = (ResponseType)configWindow.Run();
                    if (result == ResponseType.Ok)
                    {
                        _connectionName = configWindow._ConnectionName;
                        _sspi = configWindow._SSPI;
                        _serverType = configWindow._ServerType;
                        _driver = configWindow._Driver;
                        _server = configWindow._Server;
                        _database = configWindow._Database;
                        _user = configWindow._User;
                        _password = configWindow._Password;
                        _connectionType = configWindow._ConnectionType;
                        ServerInfo serverInfo = new ServerInfo(_serverType, _driver, _server, _database, _user, _password, _sspi.ToString(), _connectionType.ToString(), _connectionName);
                        XmlUtil.UpdateConfig(ConfigFile, cnf, _connectionName, serverInfo);
                        FillConnections();
                    }
                    configWindow.Destroy();
                }
            }
        }
		
        protected virtual void OnButton44Clicked (object sender, EventArgs e)
		{
            if (Connections.GetSelectedItem(0) != null)
            {
                object item;
                try
                {
                    item = Connections.GetSelectedItem(0);
                }
                catch (ArgumentException)
                {
                    return;
                }
                MessageDialog md = new MessageDialog(this, DialogFlags.Modal, MessageType.Question, ButtonsType.YesNo, "Do you want to delete this entry?");
                ResponseType responseType = (ResponseType) md.Run();
                if (responseType.Equals(ResponseType.Yes))
                {
                    XmlUtil.DeleteConfig(ConfigFile, item.ToString());
                    FillConnections();
                }
                md.Destroy();
            }
		}
		
        protected virtual void OnButton45Clicked (object sender, EventArgs e)
		{
            if (Connections.GetSelectedItem(0) != null)
            {
                string cnf = Connections.GetSelectedItem(0).ToString();
                XmlUtil.MakeDefaultConfig(ConfigFile, cnf);
                FillConnections();
            }
        }
        
        protected virtual void OnConnectionsRowActivated (object o, RowActivatedArgs args)
		{
            OnButton43Clicked(o, null);
		}
    }
}
