//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.3603
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Threading;
//using System.Threading.Tasks;
using Gtk;
using Microsoft.FSharp.Collections;
using Pango;
using SqlDynamite.Common;
using SqlDynamite.Util;

namespace SqlDynamiteX
{
    public partial class MainWindow : Window
    {
        #region Fields

        private static readonly string HistoryFile;
        private static readonly string LogFile;
        private readonly List<string> _words;
        private readonly List<Tag> _mTags = new List<Tag>();
        private readonly ListStore _items;
        private List<Tuple<string, ObjectType, string>> _objects;
        private string _serverType;
        private string _driver;
        private string _server;
        private string _database;
        private string _user;
        private string _password;
        private bool _sspi;
        private ConnectionType _connectionType;
        //private Task _task;
        private CancellationTokenSource _cancellationTokenSource = new CancellationTokenSource();
        //private CancellationToken _cancellationToken;
		private bool _tableCheck = true;
		private bool _pkCheck = true;
		private bool _fkCheck = true;
		private bool _ixCheck = true;
		private bool _spCheck = true;
		private bool _fnCheck = true;
		private bool _viewCheck = true;
		private bool _trCheck = true;
		private bool _packageCheck = true;
		private bool _sequenceCheck = true;
        private bool _synonymCheck = true;
        private bool _typeCheck = true;
        private bool _jobCheck = true;
        private bool _reportCheck = true;
        private bool _serviceBrokerCheck = true;
        private bool _computedColumnsCheck = true;
        private bool _searchInNames = true;
		private bool _searchInDef = true;

        private bool _matchCase;
        private bool _syntaxHighlighting;

        struct Tag
        {
            public int StartPosition;
            public int EndPosition;
            public Color Color;
        }

        #endregion

        #region Constructors

        static MainWindow()
        {
            string appdata = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
            if (!Directory.Exists(appdata + "/SQL Dynamite"))
            {
                Directory.CreateDirectory(appdata + "/SQL Dynamite");
            }
            HistoryFile = appdata + "/SQL Dynamite/SQL_Dynamite_HISTORY.txt";
            LogFile = appdata + "/SQL Dynamite/SQL_Dynamite_LOG.txt";
        }

        public MainWindow()
            : base(WindowType.Toplevel)
        {
            Build();

            if (list1.Columns.Length == 0)
            {
                CellRendererText nameCell = new CellRendererText();
                CellRendererText typeCell = new CellRendererText();
                TreeViewColumn nameColumn = new TreeViewColumn("Name", nameCell);
                TreeViewColumn typeColumn = new TreeViewColumn("Type", typeCell);
                nameColumn.PackStart(nameCell, true);
                nameColumn.AddAttribute(nameCell, "text", 0);
                typeColumn.PackStart(typeCell, true);
                typeColumn.AddAttribute(typeCell, "text", 1);
                list1.AppendColumn(nameColumn);
                list1.AppendColumn(typeColumn);
            }

            _items = new ListStore(typeof(string), typeof(string));
            list1.Model = _items;

            _words = new List<string>();
            if (!File.Exists(HistoryFile))
            {
                File.CreateText(HistoryFile);
            }
            else
            {
                _words.AddRange(File.ReadAllLines(HistoryFile));
                _words.Reverse();
                foreach (string word in _words)
                {
                    Search.AppendText(word);
                }
            }
            FillConnections();
            if (Connections.Model.IterNChildren() > 0)
            {
                IEnumerable<Tuple<string, bool>> confs = XmlUtil.SelectConfig(ListWindow.ConfigFile);
                foreach (Tuple<string, bool> conf in confs)
                {
                    if (conf.Item2)
                    {
                        Connections.SetComboBoxText(conf.Item1);
                        break;
                    }
                }
                if (Connections.ActiveText == "")
                {
                    Connections.Active = 0;
                }
            }
            else
            {
                ConfigWindow configWindow = new ConfigWindow();
                ResponseType result = (ResponseType)configWindow.Run();
                if (result == ResponseType.Ok)
                {
                    XmlUtil.InsertConfig(ListWindow.ConfigFile, configWindow._ConnectionName, configWindow._ServerType,
                                            configWindow._Driver, configWindow._Server,
                                            configWindow._Database, configWindow._User,
                                            configWindow._Password, configWindow._SSPI.ToString(),
                                            configWindow._ConnectionType.ToString());
                    FillConnections();
                }
                configWindow.Destroy();
            }
            Connections_SelectionChanged(this, null);

            Connections.Changed += Connections_SelectionChanged;
            list1.Selection.Changed += list1_SelectionChanged;
            InitializeTags();
        }

        #endregion

        #region Private Methods

        private void FillConnections()
        {
            string currentConnection = Connections.ActiveText;
            CellRendererText cell = new CellRendererText();
            Connections.PackStart(cell, true);
            ListStore store = new ListStore(typeof(string));
            Connections.Model = store;
            IEnumerable<Tuple<string, bool>> cns = XmlUtil.SelectConfig(ListWindow.ConfigFile);
            foreach (Tuple<string, bool> cn in cns)
            {
                Connections.AppendText(cn.Item1);
            }
            Connections.SetComboBoxText(currentConnection);
        }

        private void FillListBox()
        {
            List<Tuple<string, ObjectType, string>> list = new List<Tuple<string, ObjectType, string>>();

            foreach (Tuple<string, ObjectType, string> pair in _objects)
            {
                Tuple<string, ObjectType, string> pair1 = pair;
                bool keyFound = _items.Cast<object[]>().Any(item => item[0].ToString() == pair1.Item1);

                if (!keyFound)
                {
                    list.Add(new Tuple<string, ObjectType, string>(pair.Item1, pair.Item2, _database));
                }
            }
            list.Sort(new TupleComparer());
            foreach (Tuple<string, ObjectType, string> pair in list)
            {
                _items.AppendValues(new[] {pair.Item1, pair.Item2.ToString()});
            }
            statusbar1.Push(1, list1.Model.IterNChildren() + " objects found");
        }

        private void SearchObjects(string query, string searchStr, MetadataFinder finder, List<ObjectType> types,
            bool[] boxes)
        {
            /*_cancellationTokenSource = new CancellationTokenSource();
            _cancellationToken = _cancellationTokenSource.Token;

            if (_task != null && _task.Status == TaskStatus.Running)
            {
                _cancellationTokenSource.Cancel();
            }*/

            progressbar1.Visible = true;
            progressbar1.Fraction = 0;

            bool caseSensitive = selectFontAction.Active;

            /*FSharpList<Tuple<string, ObjectType>> objects = null;

            _task = Task.Factory.StartNew(() =>
            {
                objects = MetadataFinder.SearchInNames(finder, boxes, query, _cancellationTokenSource);
            }, _cancellationToken)
                .ContinueWith(task => progressbar1.Fraction = 0.25, _cancellationToken)
                .ContinueWith(task => objects = MetadataFinder.JoinLists(objects, MetadataFinder.SearchInDefinitionsByName(finder, boxes, searchStr, caseSensitive, _cancellationTokenSource)), _cancellationToken)
                .ContinueWith(task => progressbar1.Fraction = 0.5, _cancellationToken)
                .ContinueWith(task => objects = MetadataFinder.JoinLists(objects, MetadataFinder.SearchInDefinitionsByContent(finder, boxes, searchStr, types.Aggregate(FSharpList<ObjectType>.Empty, (current, type) => new FSharpList<ObjectType>(type, current)), caseSensitive, _cancellationTokenSource)), _cancellationToken)
                .ContinueWith(task => progressbar1.Fraction = 1, _cancellationToken)
                .ContinueWith(task => _objects = new List<Tuple<string, ObjectType>>(objects), _cancellationToken)
                .ContinueWith(task => CompleteSearch(), _cancellationToken);*/
                
			FSharpList<Tuple<string, ObjectType, string>> objects = finder.SearchInNames(boxes, query, _cancellationTokenSource);
            progressbar1.Fraction = 0.25;
			objects = MetadataFinder.JoinLists(objects, finder.SearchInDefinitionsByName(boxes, searchStr, caseSensitive, _cancellationTokenSource));
            progressbar1.Fraction = 0.5;
			objects = MetadataFinder.JoinLists(objects, finder.SearchInDefinitionsByContent(boxes, searchStr, types.Aggregate(FSharpList<ObjectType>.Empty, (current, type) => new FSharpList<ObjectType>(type, current)), caseSensitive, _cancellationTokenSource));
            progressbar1.Fraction = 1;
            _objects = new List<Tuple<string, ObjectType, string>>(objects);
            CompleteSearch();
        }

        private void CompleteSearch()
        {
            FillListBox();
            btn_Stop.Sensitive = false;
            btn_Search.Sensitive = true;
            progressbar1.Visible = false;
        }

        private static void ShowAboutDialog()
        {
            AboutDialog dialog = new AboutDialog();
            Assembly asm = Assembly.GetExecutingAssembly();

            dialog.ProgramName = (asm.GetCustomAttributes(
                typeof(AssemblyTitleAttribute), false)[0]
                as AssemblyTitleAttribute).Title;

            dialog.Version = asm.GetName().Version.ToString();

            dialog.Comments = (asm.GetCustomAttributes(
                typeof(AssemblyDescriptionAttribute), false)[0]
                as AssemblyDescriptionAttribute).Description;

            dialog.Copyright = (asm.GetCustomAttributes(
                typeof(AssemblyCopyrightAttribute), false)[0]
                as AssemblyCopyrightAttribute).Copyright;

            dialog.Run();

            dialog.Destroy();
        }

        #endregion

        #region Event Handlers

        private void list1_SelectionChanged(object sender, EventArgs e)
        {
            if (list1.GetSelectedItem(0) != null)
            {
                MetadataFinder finder = ConfigWindow.CreateMetadataFinder(_serverType);
                if (finder == null) return;
                string searchStr = list1.GetSelectedItem(0).ToString();
                box1.Buffer.Text = "";
                ObjectType type = MetadataFinder.String2ObjectType(list1.GetSelectedItem(1).ToString());
                string cstring = finder.MakeConnectionString(_driver, _server, _database, _user, _password, _sspi, _connectionType);
                if (!string.IsNullOrWhiteSpace(cstring))
                {
                    finder.EstablishConnection(cstring, _connectionType, _database);
                }
                else
                {
                    var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, "Connection string is empty") { Title = "Error" };
                    md.Run();
                    md.Destroy();
                    return;
                }

                try
                {
                    string content = finder.RetrieveDefinition(searchStr, type, null);
                    HighlightSyntax(content);
                }
                catch (Exception exc)
                {
                    var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, exc.GetExceptionMessages()) { Title = "Error" };
                    md.Run();
                    md.Destroy();
                }
            }
        }

        protected void OnDeleteEvent(object sender, DeleteEventArgs a)
        {
            Application.Quit();
            a.RetVal = true;
        }

        protected virtual void OnQuitActionToggled(object sender, EventArgs e)
        {
            Application.Quit();
        }

        protected virtual void OnAddActionToggled(object sender, EventArgs e)
        {
            var lw = new ListWindow();
            lw.Run();
            FillConnections();
        }

        private void Connections_SelectionChanged(object sender, EventArgs e)
        {
            if (!string.IsNullOrWhiteSpace(Connections.ActiveText))
            {
                ServerInfo crs =
                    XmlUtil.SelectConfig(ListWindow.ConfigFile, Connections.ActiveText);
                if (crs != null)
                {
                    _serverType = crs.ServerType;
                    _driver = crs.Driver;
                    _server = crs.Server;
                    _database = crs.Database;
                    _user = crs.User;
                    _password = crs.Password;
                    _sspi = bool.Parse(crs.SSPI);
                    _connectionType = crs.ConnectionType == "ODBC"
                        ? ConnectionType.ODBC
                        : crs.ConnectionType == "OLEDB" ? ConnectionType.OLEDB : ConnectionType.NET;
                }
            }
        }

        protected virtual void OnStopActionToggled(object sender, EventArgs e)
        {
            _cancellationTokenSource.Cancel();
        }

        protected virtual void OnMediaPlayActionToggled(object sender, EventArgs e)
        {
            statusbar1.Pop(1);
            MetadataFinder finder = ConfigWindow.CreateMetadataFinder(_serverType);
            if (finder == null) return;
            var types = new List<ObjectType>();
            if (_spCheck) types.Add(ObjectType.PROCEDURE);
            if (_fnCheck) types.Add(ObjectType.FUNCTION);
            if (_tableCheck) types.Add(ObjectType.TABLE);
            if (_viewCheck) types.Add(ObjectType.VIEW);
            if (_trCheck) types.Add(ObjectType.TRIGGER);
            if (_pkCheck) types.Add(ObjectType.PRIMARY_KEY);
            if (_fkCheck) types.Add(ObjectType.FOREIGN_KEY);
            if (_ixCheck) types.Add(ObjectType.INDEX);
            if (_packageCheck) types.Add(ObjectType.PACKAGE);
            if (_sequenceCheck) types.Add(ObjectType.SEQUENCE);
            if (_synonymCheck) types.Add(ObjectType.SYNONYM);
            if (_typeCheck) types.Add(ObjectType.TYPE);
            if (_jobCheck) types.Add(ObjectType.JOB);
            if (_reportCheck) types.Add(ObjectType.REPORT);
            if (_serviceBrokerCheck) types.Add(ObjectType.SERVICE_QUEUE);
            if (_computedColumnsCheck) types.Add(ObjectType.COMPUTED_COLUMN);
            if (types.Count == 0) return;
            if (_searchInNames == false && _searchInDef == false) return;
            if (!string.IsNullOrWhiteSpace(Search.ActiveText)
                && !_words.Contains(Search.ActiveText.Trim()))
            {
                string activeText = Search.ActiveText.Trim();
                _words.Add(activeText);
                Search.InsertText(0, activeText);
                File.AppendAllText(HistoryFile, activeText + Environment.NewLine);
            }
            _items.Clear();
            try
            {
                string cstring = finder.MakeConnectionString(_driver, _server, _database, _user, _password, _sspi, _connectionType);
                if (!string.IsNullOrWhiteSpace(cstring))
                {
                    finder.EstablishConnection(cstring, _connectionType, _database);
                }
                else
                {
                    var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, "Connection string is empty") { Title = "Error" };
                    md.Run();
                    md.Destroy();
                    return;
                }
            }
            catch (Exception exception)
            {
                File.AppendAllText(LogFile,
                                   string.Format("{0}: {1}{2}", DateTime.Now, exception.GetExceptionMessages(), Environment.NewLine));
                var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, exception.GetExceptionMessages()) { Title = "Error while searching in names" };
                md.Run();
                md.Destroy();
                return;
            }
            _objects = new List<Tuple<string, ObjectType, string>>();
            bool[] boxes = new[]
                               {
                                   _tableCheck,
                                   _pkCheck,
                                   _fkCheck,
                                   _ixCheck,
                                   _spCheck,
                                   _fnCheck,
                                   _viewCheck,
                                   _trCheck,
			                       _sequenceCheck,
				                   _packageCheck,
                                   _synonymCheck,
                                   _typeCheck,
                                   _jobCheck,
                                   _reportCheck,
                                   _serviceBrokerCheck,
                                   _computedColumnsCheck,
                                   _searchInNames,
                                   _searchInDef
                               };
            box1.Buffer.Text = "";
            btn_Search.Sensitive = false;
            btn_Stop.Sensitive = true;
            string query = _searchInNames
                               ? finder.GenerateNameScript(Search.ActiveText.Trim(), types.Aggregate(FSharpList<ObjectType>.Empty, (current, type) => new FSharpList<ObjectType>(type, current)), _matchCase)
                               : null;
            SearchObjects(query, Search.ActiveText.Trim().Replace("'", "''"), finder, types, boxes);
        }

        protected virtual void OnPreferencesActionActivated(object sender, EventArgs e)
        {
            CheckBoxes checkBoxes = new CheckBoxes();
            bool[] boxes = new[]
			{
				_tableCheck,
				_pkCheck,
				_fkCheck,
				_ixCheck,
				_spCheck,
				_fnCheck,
				_viewCheck,
				_trCheck,
				_sequenceCheck,
				_packageCheck,
                _synonymCheck,
                _typeCheck,
                _jobCheck,
                _reportCheck,
                _serviceBrokerCheck,
                _computedColumnsCheck,
                _searchInNames,
				_searchInDef
			};
            checkBoxes.SetCheckBoxesValues(boxes);
            ResponseType result = (ResponseType)checkBoxes.Run();
            if (result == ResponseType.Ok)
            {
                _tableCheck = checkBoxes.Boxes[0];
                _pkCheck = checkBoxes.Boxes[1];
                _fkCheck = checkBoxes.Boxes[2];
                _ixCheck = checkBoxes.Boxes[3];
                _spCheck = checkBoxes.Boxes[4];
                _fnCheck = checkBoxes.Boxes[5];
                _viewCheck = checkBoxes.Boxes[6];
                _trCheck = checkBoxes.Boxes[7];
                _sequenceCheck = checkBoxes.Boxes[8];
                _packageCheck = checkBoxes.Boxes[9];
                _synonymCheck = checkBoxes.Boxes[10];
                _typeCheck = checkBoxes.Boxes[11];
                _jobCheck = checkBoxes.Boxes[12];
                _reportCheck = checkBoxes.Boxes[13];
                _serviceBrokerCheck = checkBoxes.Boxes[14];
                _computedColumnsCheck = checkBoxes.Boxes[15];
                _searchInNames = checkBoxes.Boxes[16];
                _searchInDef = checkBoxes.Boxes[17];
            }
            checkBoxes.Destroy();
        }

        protected virtual void OnSelectColorActionToggled(object sender, EventArgs e)
        {
            _syntaxHighlighting = selectColorAction.Active;
        }

        protected virtual void OnConvertActionToggled(object sender, EventArgs e)
        {
            box1.WrapMode = convertAction.Active ? Gtk.WrapMode.Word : Gtk.WrapMode.None;
        }

        protected virtual void OnSelectFontActionToggled(object sender, EventArgs e)
        {
            _matchCase = selectFontAction.Active;
        }

        protected virtual void OnInfoActionActivated(object sender, EventArgs e)
        {
            ShowAboutDialog();
        }

        protected virtual void OnSaveActionActivated(object sender, EventArgs e)
        {
            var dialog = new FileChooserDialog("Save DDL script", this, FileChooserAction.Save,
                                    "Save", ResponseType.Accept,
                                    "Cancel", ResponseType.Cancel) { Filter = new FileFilter() };
            dialog.Filter.AddPattern("*.sql");
            ResponseType responseType = (ResponseType)dialog.Run();
            if (responseType.Equals(ResponseType.Yes))
            {
                File.WriteAllText(dialog.Filename, box1.Buffer.Text);
            }
            dialog.Destroy();
        }

        protected void Drivers_Activated(object sender, EventArgs e)
        {
            var drivers = "";
            foreach (var tuple in MetadataFinderHelper.ProvidersList.Distinct())
            {
                drivers += $"{tuple.Item1}: {tuple.Item2}{Environment.NewLine}{Environment.NewLine}";
            }
            var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Info, ButtonsType.Ok, drivers) { Title = "Installed .NET Data Providers" };
            md.Run();
            md.Destroy();
        }

        #endregion

        #region Text Box

        private void InitializeTags()
        {
            box1.Buffer = new TextBuffer(new TextTagTable());
            foreach (Color color in ConfigWindow.SyntaxProvider.Colors)
            {
                string str = color.ToColorString();
                TextTag tag = new TextTag(str)
                {
                    Foreground = str
                };

                if (color.Equal(ConfigWindow.SyntaxProvider.SearchColor))
                {
                    tag.Weight = Weight.Bold;
                    tag.Background = ConfigWindow.SyntaxProvider.SearchBackgroundColor.ToColorString();
                }
                box1.Buffer.TagTable.Add(tag);
            }
            box1.Buffer.InsertText += CheckWordsInRun;
            box1.WrapMode = Gtk.WrapMode.None;
        }

        private void HighlightSyntax(string content)
        {
            if (content == null) return;

            box1.Buffer.Text = content;
            
            Format(_syntaxHighlighting);
        }

        void Format(bool highlightSyntax)
        {
            for (int i = 0; i < _mTags.Count; i++)
            {
                if (highlightSyntax)
                {
                    if (!_mTags[i].Color.Equal(ConfigWindow.SyntaxProvider.SearchColor))
                    {
                        TextIter start = box1.Buffer.GetIterAtOffset(_mTags[i].StartPosition);
                        TextIter end = box1.Buffer.GetIterAtOffset(_mTags[i].EndPosition);
                        string str = _mTags[i].Color.ToColorString();
                        try
                        {
                            box1.Buffer.ApplyTag(str, start, end);
                        }
                        catch (AccessViolationException)
                        {
                            _mTags.Clear();
                            return;
                        }
                        catch (Exception exception)
                        {
                            var md = new MessageDialog(this, DialogFlags.Modal, MessageType.Error, ButtonsType.Ok, exception.GetExceptionMessages());
                            md.Run();
                            md.Destroy();
                            _mTags.Clear();
                            return;
                        }
                    }
                }
                if (_mTags[i].Color.Equal(ConfigWindow.SyntaxProvider.SearchColor))
                {
                    TextIter start = box1.Buffer.GetIterAtOffset(_mTags[i].StartPosition);
                    TextIter end = box1.Buffer.GetIterAtOffset(_mTags[i].EndPosition);
                    box1.Buffer.ApplyTag(ConfigWindow.SyntaxProvider.SearchColor.ToColorString(), start, end);
                }
            }
            _mTags.Clear();
        }

        private void CheckWordsInRun(object o, InsertTextArgs args)
        {
            if (string.IsNullOrWhiteSpace(Search.ActiveText)) return;
            string st = Search.ActiveText.Trim();
            bool hasUnderline = st.StartsWith("_") || st.EndsWith("_");
            bool hasPercent = st.StartsWith("%") || st.EndsWith("%");
            if (hasUnderline || hasPercent)
            {
                st = st.Trim('_', '%');
            }
            string[] strings = st.Split(' ');
            List<string> searchStrings =
                (from s in strings where !string.IsNullOrWhiteSpace(s.Trim()) select _matchCase ? s : s.ToLower()).ToList();

            string text = args.Text;

            int sIndex = 0;
            int eIndex = 0;
            for (int i = 0; i < text.Length; i++)
            {
                if (char.IsWhiteSpace(text[i]) || ConfigWindow.SyntaxProvider.Separators.Contains(text[i]))
                {
                    if (i > 0 && !(Char.IsWhiteSpace(text[i - 1]) || ConfigWindow.SyntaxProvider.Separators.Contains(text[i - 1])))
                    {
                        eIndex = i - 1;
                        string word = text.Substring(sIndex, eIndex - sIndex + 1);
                        string s = _matchCase ? word : word.ToLower();

                        bool wordFound = searchStrings.Any(s.Contains);

                        if (wordFound)
                        {
                            int indexOf = s.IndexOf(_matchCase ? st : st.ToLower());
                            Tag t = new Tag
                            {
                                StartPosition = sIndex + indexOf,
                                EndPosition = eIndex + 1 - s.Length + indexOf + st.Length,
                                Color = ConfigWindow.SyntaxProvider.SearchColor
                            };
                            _mTags.Add(t);
                        }
                        else if (ConfigWindow.SyntaxProvider.IsKnownTag(s.ToLower()))
                        {
                            Tag t = new Tag
                            {
                                StartPosition = sIndex,
                                EndPosition = eIndex + 1,
                                Color = ConfigWindow.SyntaxProvider.Tags[s.ToLower()]
                            };
                            _mTags.Add(t);
                        }
                    }
                    sIndex = i + 1;
                }
            }

            string lastWord = text.Substring(sIndex, text.Length - sIndex);
            string ls = _matchCase ? lastWord : lastWord.ToLower();

            bool lwordFound = searchStrings.Any(ls.Contains);

            if (lwordFound)
            {
                int indexOf = ls.ToLower().IndexOf(_matchCase ? st : st.ToLower());
                Tag t = new Tag
                {
                    StartPosition = sIndex + indexOf,
                    EndPosition = sIndex + indexOf + st.Length,
                    Color = ConfigWindow.SyntaxProvider.SearchColor
                };
                _mTags.Add(t);
            }
            else if (ConfigWindow.SyntaxProvider.IsKnownTag(ls.ToLower()))
            {
                Tag t = new Tag
                {
                    StartPosition = sIndex,
                    EndPosition = eIndex + 1,
                    Color = ConfigWindow.SyntaxProvider.Tags[ls.ToLower()]
                };
                _mTags.Add(t);
            }
        }

        #endregion
    }
}
